

#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <PIDController.h>
#include <Encoder.h>
#include <EEPROM.h>

LiquidCrystal_I2C lcd(0x27,16,2);
PIDController pid;
Encoder Enc(3, 4);

//E/A Definitionen
#define Rechtslauf 5
#define Linkslauf  6
#define Rotorpoti  A0
#define Taster  2

const char* Richtung[] = { "N","N NO","NO","O NO","O","O SO","SO","S SO","S","S SW","SW","W SW","W","W NW","NW","N NW","N" };
const char* Steuerung [] = { "PWM","Relais" };

volatile bool klick = false;
bool Positionieren;
bool RotorErkannt;
bool edit = false;

char Init;
byte Schrittweite;
byte Positionsfenster;
byte Potityp;
byte Steuerungstyp;

int Nord_0 = 160;
int Nord_360 = 505;
int Rotorstellung;
int Sollposition = 0;
int outpwm;
int Screen;

long AnzeigeTimeStamp;
long PosTimeStamp;





void setup() {
  Serial.begin(9600); 

  pinMode(Taster, INPUT_PULLUP);
  pinMode(Rechtslauf,OUTPUT);
  pinMode(Linkslauf,OUTPUT);
  analogWrite(Linkslauf,0);
  analogWrite(Rechtslauf,0);

  EEPROM.get(8,Init);
  if (Init == 'D'){
    EEPROM.get(0,Nord_0);
    EEPROM.get(2,Nord_360);
    EEPROM.get(4,Schrittweite);
    EEPROM.get(5,Positionsfenster);
    EEPROM.get(6,Potityp);
    EEPROM.get(7,Steuerungstyp);
  }
  else{
    Nord_0=0;
    Nord_360=512;
    Schrittweite=5;
    Positionsfenster=2;
    Potityp=3;
    Steuerungstyp=0;
    Init='D';
    EEPROM.put(0,Nord_0);
    EEPROM.put(2,Nord_360);
    EEPROM.put(4,Schrittweite);
    EEPROM.put(5,Positionsfenster);
    EEPROM.put(6,Potityp);
    EEPROM.put(7,Steuerungstyp);
    EEPROM.put(8,Init);
  }
  
  if (Potityp == 10){
    analogReference(INTERNAL);
  }
  else{
    analogReference(DEFAULT);
  }
  
  attachInterrupt(digitalPinToInterrupt(Taster), ISR_Taste, RISING);

  pid.begin();          
  pid.tune(2, 5, 1);    
  pid.limit(0, 255);

  lcd.init();                      
  lcd.backlight();
  lcd.setCursor(1,0);
  lcd.print("Rotor-Controll");
  lcd.setCursor(3,1);
  lcd.print("startet ....");
  delay(3000);
  lcd.clear();
  klick = false;
  AnzeigeTimeStamp = millis();
  PosTimeStamp = millis();
}

void loop() {
  
  if (millis() - PosTimeStamp > 30){
    Positionen_lesen();
    Positioniern();  
    PosTimeStamp=millis();
  }

  if (millis() - AnzeigeTimeStamp > 100) {  
    Anzeige();
    AnzeigeTimeStamp = millis(); 
  }
}
